# if we want to build the volume_id "extra" package or not
# 0 - do not build the package
# 1 - build it
%define volume_id 1

# if we want to build the scsi_id "extra" package or not
# 0 - do not build the package
# 1 - build it
%define scsi_id 1

# if we want to build pam_console support
# 0 - do not build the package
# 1 - build it
%define pam_console 1

%define devlabel 0

%define udev_kernel_includes 2.6.6

%define debug false

Summary: A userspace implementation of devfs
Name: udev
Version: 029
Release: 1
License: GPL
Group: Utilities/System
Source: ftp://ftp.kernel.org/pub/linux/utils/kernel/hotplug/%{name}-%{version}.tar.bz2
Source1: udev.rules
Source2: udev.permissions
Source3: udev.conf
Source4: pam_console.dev
Source5: selinux.dev
Source6: udev.sysconfig
Source7: udev.hotplug
%if %{devlabel}
Source9: devlabel.dev
%endif

%if %{pam_console}
Source10: pam_console_setowner-1.0.tgz
%endif

Source11: ata_identify.c
Source12: ata_identify-Makefile

Source13: udev.get_persistent_device_name.sh
Source14: udev.get_unique_hardware_path.sh
Source15: udev.get_unique_drive_id.sh
Source16: udev.rules.persistent

Source20: start_udev
Source21: udev-setup-initrd

Source30: include-linux-%{udev_kernel_includes}.tar.bz2


#Patch0: udev-bk.patch
Patch1: udev-025-klibc-strnlen.patch
Patch2: udev-025-volsbin.patch

Patch12: udev-029-lseek64.patch
Patch13: udev-029-preserve.patch

Patch30: include-linux-2.6.6-fdset.patch
Patch31: include-linux-2.6.6-ia64-page.patch
Patch32: include-linux-2.6.6-ia64-break.patch
Patch33: include-linux-2.6.6-s390-bitops.patch

ExclusiveOS: Linux
URL: http://kernel.org/pub/linux/utils/kernel/hotplug/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Prereq: /bin/sh fileutils hotplug
BuildRequires: sed

%if %{pam_console}
BuildRequires: pam-devel
Requires: pam
%endif

%description
udev is a implementation of devfs in userspace using sysfs and
/sbin/hotplug. It requires a 2.6 kernel to run properly.

%package -n udev-persistent
Summary: Persistent device naming with udev
Group: Utilities/System
PreReq: udev = 0:%{version}-%{release}
Requires: sed 

%description -n udev-persistent
udev-persistent enables persistent device naming with udev.


%prep
%if %{pam_console}
%setup -q -a 10 -a 30
%else
%setup -q
%endif
#%patch0 -p1 -b .bk
%patch1 -p1 -b .strnlen
%patch2 -p1 -b .volsbin
%patch12 -p1 -b .lseek64
%patch13 -p1 -b .preserve

mkdir ata_identify
cp %{SOURCE11} ata_identify
cp %{SOURCE12} ata_identify/Makefile

mkdir -p klibc/klibc/linux
mv include-linux-%{udev_kernel_includes} klibc/klibc/linux/include
pushd klibc/klibc/linux/include
for i in `find -type f`;do grep -Eq 'linux/(autoconf|config).h' $i || continue ; sed '/linux\/autoconf.h/d;/linux\/config.h/d' < $i > $i. ; mv $i. $i ; done
ln -sv asm-`uname -m |
sed -e s/i.86/i386/ \
-e s/sun4u/sparc64/ \
-e s/arm.*/arm/ \
-e s/sa110/arm/ \
-e s/s390x/s390/ \
-e s/parisc64/parisc/` asm
popd

%patch30 -p1 -b .fdset
%patch31 -p1 -b .page
%patch32 -p1 -b .break
%patch33 -p1 -b .bitops

%build
make CC="gcc $RPM_OPT_FLAGS" \
        USE_KLIBC=false \
	USE_LOG=true DEBUG=%{debug} \
	EXTRAS=""

mv udev udev.dynamic
mv udevd udevd.dynamic
make clean
#$PWD/klibc/klibc/linux" 
#rm -f *.o
#rm -f */*.o */*.a

make CC="gcc $RPM_OPT_FLAGS -D__user=''"  KERNEL_DIR="$PWD/klibc/klibc/linux" \
        USE_KLIBC=true \
	USE_LOG=true		\
	DEBUG=%{debug}		\
	EXTRAS="	\
%if %{scsi_id}
        extras/scsi_id  \
%endif
%if %{volume_id}
        extras/volume_id  \
%endif
        ata_identify"



%if %{pam_console}
pushd pam_console_setowner
make
popd
%endif


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sbindir}

make DESTDIR=$RPM_BUILD_ROOT install \
	EXTRAS="	\
%if %{scsi_id}
	extras/scsi_id	\
%endif
%if %{volume_id}
        extras/volume_id  \
%endif
        ata_identify"


rm -f $RPM_BUILD_ROOT%{_sysconfdir}/udev/udev.rules
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/udev/udev.permissions
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/init.d/udev

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/udev/{rules.d,permissions.d}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dev.d/{default,block}
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/50-udev.rules
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/udev/permissions.d/50-udev.permissions

install -m 0644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/udev/udev.conf
install -m 0755 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/dev.d/default
install -m 0755 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/dev.d/default
%if %{devlabel}
install -m 0755 %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/dev.d/block
%endif
install -m 0755 udev $RPM_BUILD_ROOT/sbin/udev.static
install -m 0755 udev.dynamic $RPM_BUILD_ROOT/sbin/udev
install -m 0755 udevd $RPM_BUILD_ROOT/sbin/udevd.static
install -m 0755 udevd.dynamic $RPM_BUILD_ROOT/sbin/udevd

#persistent
install -m 0755 %{SOURCE13} $RPM_BUILD_ROOT/sbin
install -m 0755 %{SOURCE14} $RPM_BUILD_ROOT/sbin
install -m 0755 %{SOURCE15} $RPM_BUILD_ROOT/sbin
install -m 0644 %{SOURCE16} $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/51-udev-persistent.rules
install -m 0644 extras/volume_id/s390-dasd.rules $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/52-udev-s390-persistent.rules

%if %{pam_console}
install -m 0755 pam_console_setowner/pam_console_setowner $RPM_BUILD_ROOT/sbin
%endif

mkdir $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 0644 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/udev

rm -f $RPM_BUILD_ROOT%{_sysconfdir}/hotplug.d/default/udev.hotplug
install -m 0644 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/udev
install -m 0755 %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/hotplug.d/default/udev.hotplug


mkdir -p $RPM_BUILD_ROOT%{_datadir}/udev
install -m 0644 %{SOURCE20} $RPM_BUILD_ROOT/sbin/start_udev
install -m 0644 %{SOURCE21} $RPM_BUILD_ROOT%{_datadir}/udev/udev-setup-initrd


#%post
#/sbin/chkconfig --add udev

%preun
if [ $1 = 0 -a -f %{_sysconfdir}/rc.d/init.d/udev ]; then
	/sbin/chkconfig --del udev
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc COPYING README TODO ChangeLog HOWTO*  docs/*
%doc etc/udev/udev.rules.{examples,redhat}
%doc etc/udev/udev.permissions.redhat

%attr(0755,root,root) %dir /udev

%attr(0755,root,root) /sbin/udev
%attr(0755,root,root) /sbin/udev.static
%attr(0755,root,root) /sbin/udevsend
%attr(0755,root,root) /sbin/udevd
%attr(0755,root,root) /sbin/udevd.static
%attr(0755,root,root) /sbin/udevstart
%attr(0755,root,root) /sbin/start_udev
%attr(755,root,root) /sbin/ata_identify

%attr(0755,root,root) %{_bindir}/udevtest
%attr(0755,root,root) %{_bindir}/udevinfo

%if %{pam_console}
%attr(0755,root,root) /sbin/pam_console_setowner
%endif

%attr(0755,root,root) %dir %{_sysconfdir}/dev.d/
%attr(0755,root,root) %dir %{_sysconfdir}/dev.d/default
%config %attr(0755,root,root) %{_sysconfdir}/dev.d/net/hotplug.dev
%config %attr(0755,root,root) %{_sysconfdir}/dev.d/default/pam_console.dev
%config %attr(0755,root,root) %{_sysconfdir}/dev.d/default/selinux.dev
%attr(0755,root,root) %dir %{_sysconfdir}/udev/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/rules.d/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/permissions.d/
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/udev/udev.conf
%config %attr(0644,root,root) %{_sysconfdir}/udev/rules.d/50-udev.rules
%config %attr(0644,root,root) %{_sysconfdir}/udev/permissions.d/50-udev.permissions
%attr(0755,root,root) %{_sysconfdir}/hotplug.d/default/udev.hotplug

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/sysconfig/udev

%attr(0644,root,root) %{_mandir}/man8/udev*.8*

%attr(0644,root,root) %{_datadir}/udev/udev-setup-initrd

%if %{scsi_id}
	%attr(755,root,root) /sbin/scsi_id
	%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/scsi_id.config
	%attr(0644,root,root) %{_mandir}/man8/scsi_id*.8*
%endif
%if %{volume_id}
        %attr(755,root,root) /sbin/udev_volume_id
%endif


%files -n udev-persistent
%config %attr(0644,root,root) %{_sysconfdir}/udev/rules.d/51-udev-persistent.rules
%attr(0755,root,root) /sbin/udev.get_persistent_device_name.sh
%attr(0755,root,root) /sbin/udev.get_unique_hardware_path.sh
%attr(0755,root,root) /sbin/udev.get_unique_drive_id.sh
%if %{volume_id}
%attr(0644,root,root) %{_sysconfdir}/udev/rules.d/52-udev-s390-persistent.rules
%endif
%if %{devlabel}
%config %attr(0755,root,root) %{_sysconfdir}/dev.d/block/devlabel.dev
%endif



%changelog
* Tue Jul  6 2004 Harald Hoyer <harald@redhat.com> - 029-1
- version 029, added udev_remove and udev_owner to udev.conf

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Jun  8 2004 Harald Hoyer <harald@redhat.com> - 026-3
- fixed UDEV_REMOVE=no

* Tue Jun  8 2004 Harald Hoyer <harald@redhat.com> - 026-2
- udev-026
- preserve ownership of device nodes, which already exist
- do not remove device nodes if UDEV_REMOVE="no"
- added volume_id
- build with klibc

* Wed May 26 2004 Harald Hoyer <harald@redhat.com> - 025-1
- udev-025
- added ata_identify
- build nearly all with dietlibc

* Mon May 10 2004 Elliot Lee <sopwith@redhat.com> 024-6
- Turn off udevd by default for FC2

* Tue Apr 20 2004 Harald Hoyer <harald@redhat.com> - 024-5
- fixed permission for /dev/tty (FC2)

* Thu Apr 15 2004 Harald Hoyer <harald@redhat.com> - 024-4
- moved the 00- files to 50-, to let the use place his files in front

* Thu Apr 15 2004 Harald Hoyer <harald@redhat.com> - 024-3
- set UDEV_SELINUX to yes
- added UDEV_LOG

* Thu Apr 15 2004 Harald Hoyer <harald@redhat.com> - 024-2
- added /udev to filelist

* Wed Apr 14 2004 Harald Hoyer <harald@redhat.com> - 024-1
- update to 024
- added /etc/sysconfig/udev
- added selinux, pam_console, dbus support

* Fri Mar 26 2004 Harald Hoyer <harald@redhat.com> - 023-1
- update to 023

* Wed Mar 24 2004 Bill Nottingham <notting@redhat.com> 022-1
- update to 022

* Sun Mar 21 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- really move initscript

* Sun Feb 29 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- move chkconv to preun
- nicer url

* Wed Feb 25 2004 Harald Hoyer <harald@redhat.com> - 018-1
- changes permissions and rules

* Mon Feb 23 2004 Dan Walsh <dwalsh@redhat.com>
- Add selinux support

* Thu Feb 19 2004 Greg Kroah-Hartman <greg@kroah.com>
- add some more files to the documentation directory
- add ability to build scsi_id and make it the default

* Mon Feb 16 2004 Greg Kroah-Hartman <greg@kroah.com>
- fix up udevd build, as it's no longer needed to be build seperatly
- add udevtest to list of files
- more Red Hat sync ups.

* Thu Feb 12 2004 Greg Kroah-Hartman <greg@kroah.com>
- add some changes from the latest Fedora udev release.

* Mon Feb 2 2004 Greg Kroah-Hartman <greg@kroah.com>
- add udevsend, and udevd to the files
- add ability to build udevd with glibc after the rest is build with klibc

* Mon Jan 26 2004 Greg Kroah-Hartman <greg@kroah.com>
- added udevinfo to rpm
- added URL to spec file
- added udevinfo's man page

* Mon Jan 05 2004 Rolf Eike Beer <eike-hotplug@sf-tec.de>
- add defines to choose the init script (Redhat or LSB)

* Tue Dec 16 2003 Robert Love <rml@ximian.com>
- install the initscript and run chkconfig on it

* Tue Nov 2 2003 Greg Kroah-Hartman <greg@kroah.com>
- changes due to config file name changes

* Fri Oct 17 2003 Robert Love <rml@tech9.net>
- Make work without a build root
- Correctly install the right files
- Pass the RPM_OPT_FLAGS to gcc so we can build per the build policy
- Put some prereqs in
- Install the hotplug symlink to udev

* Mon Jul 28 2003 Paul Mundt <lethal@linux-sh.org>
- Initial spec file for udev-0.2.
